# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, playerlib, os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
core    = es.import_addon('sam/core')
monitor = es.import_addon('sam/core/monitor')
admins  = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
cmds       = ('add_ct','add_t','kick')
toggle     = ['auto_follow','randombuy','join_after_player','defer_to_human','stop','auto_vocate','walk','flipout','dont_shoot']
weapons    = ('grenades','machine_guns','snipers','pistols','rifles','rogues','sub_machine_guns')
dif        = {0:'easy',1:'normal',2:'hard',3:'expert'}
quota      = es.ServerVar('bot_quota')
quotamode  = es.ServerVar('bot_quota_mode')
difficulty = es.ServerVar('bot_difficulty')
chatter    = es.ServerVar('bot_chatter')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# ADD MAIN PAGE OPTION
	monitor.addons.append('bots')

	# POPUPS
	func.popupDelete('botsManager')
	func.popupDelete('botsSettings')
	func.popupDelete('allowedWeapons')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# REMOVE MAIN PAGE OPTION
	monitor.addons.remove('bots')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	if admins.can(ID, 'Bots Manager'):
		func.popupDelete('botsManager')
		popup = func.easymenu(popuplib.easymenu('botsManager', None, managerChoice),'home')
		popup.settitle(func.header(func.langAddon('bots','TITLE')))
		for x in cmds: popup.addoption(x, func.langAddon('bots',x.upper()))
		popup.addoption('quota', '%s: %s' % (func.langAddon('bots','QUOTA'),es.ServerVar('bot_quota')))
		popup.addoption('set', func.langAddon('bots','SETTINGS',))
		if SEND: popup.send(ID)
	else: core.home(ID)

# ------------------------------------------------------------------------------- #
def managerChoice(ID, OPTION, POPUP, PAGE=False):
	if OPTION in cmds:
		es.server.cmd('bot_%s' % OPTION)
		if OPTION == 'kick': es.server.cmd('bot_quota 0')
	elif OPTION == 'quota':
		if int(quota) < 32: quota.set(int(quota) + 1)
		else: quota.set(0)
	elif OPTION == 'set':
		func.popupDelete('botsSettings')
		popup = func.easymenu(popuplib.easymenu('botsSettings', None, settingsChoice),'botsManager')
		popup.settitle(func.header(func.langAddon('bots','SETTINGS')))
		popup.addoption('weapons', func.langAddon('bots','ALLOWED_WEAPONS'))
		popup.addoption('dif', '%s: %s' % (func.langAddon('bots','DIFFICULTY'),dif[int(difficulty)].upper()))
		popup.addoption('quotamode', '%s: %s' % (func.langAddon('bots','QUOTA_MODE'),str(quotamode).upper()))
		popup.addoption('chatter', '%s: %s' % (func.langAddon('bots','CHATTER'),str(chatter).upper()))
		for x in toggle:
			a = {0:func.langCommon('NO'),1:func.langCommon('YES')}
			popup.addoption(x, '%s: %s' % (func.langAddon('bots',x.upper()),a[int(es.ServerVar('bot_'+x))]))
		if PAGE: popup.sendPage(ID, PAGE)
		else: popup.send(ID)
	if OPTION != 'set': page(ID)

# ------------------------------------------------------------------------------- #
def settingsChoice(ID, OPTION, POPUP):
	if OPTION == 'dif':
		if int(difficulty) < 3: difficulty.set(int(difficulty)+1)
		else: difficulty.set(0)
	elif OPTION == 'quotamode':
		x = {'normal':'fill','fill':'match','match':'normal'}
		quotamode.set(x[str(quotamode)])
	elif OPTION == 'chatter':
		x = {'off':'radio','radio':'minimal','minimal':'normal','normal':'off'}
		chatter.set(x[str(chatter)])
	elif OPTION == 'weapons':
		func.popupDelete('allowedWeapons')
		popup = func.easymenu(popuplib.easymenu('allowedWeapons', None, weaponsChoice),'botsSettings')
		popup.settitle(func.header(func.langAddon('bots','SETTINGS')))
		popup.addoption('all', func.langAddon('bots','ALL_WEAPONS'))
		popup.addoption('knives', func.langAddon('bots','KNIVES_ONLY'))
		for x in weapons:
			a = {0:func.langCommon('NO'),1:func.langCommon('YES')}
			popup.addoption(x, '%s: %s' % (func.langCommon(x.upper()),a[int(es.ServerVar('bot_allow_%s' % x))]))
		popup.send(ID)
	elif OPTION in toggle:
		var = es.ServerVar('bot_'+OPTION)
		if int(var) > 0: var.set(0)
		else: var.set(1)
	if not OPTION == 'weapons':
		if OPTION in toggle: page = func.sendPage(toggle.index(OPTION)+4)
		else: page = 1
		managerChoice(ID, 'set', None, page)

# ------------------------------------------------------------------------------- #
def weaponsChoice(ID, OPTION, POPUP):
	if OPTION == 'all':
		for x in weapons: es.server.cmd('bot_allow_%s 1' % x)
	elif OPTION == 'knives':
		for x in weapons: es.server.cmd('bot_allow_%s 0' % x)
	else:
		var = es.ServerVar('bot_allow_%s' % OPTION)
		if int(var) == 0: es.server.cmd('bot_allow_%s 1' % OPTION)
		else: es.server.cmd('bot_allow_%s 0' % OPTION)
	settingsChoice(ID, 'weapons', None)

# =============================================================================== #