# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, playerlib, keyvalues, cmdlib, os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func   = es.import_addon('sam/functions')
core   = es.import_addon('sam/core')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
db     = 'sam_admins'
dbpath = func.dbPath + 'es_%s_db.txt' % db
imm    = {}
temp   = {'toggle':'yes','noadmins':None}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x ####### ADMIN PERMISSIONS ###### xx #
access = ['Admins Manager','Addons Monitor','Kick','Unban','Manage Teams','Slay','Mute','Admin Sounds',
		  'Server Commands','Server RCON','Fun Controls','Admins Chat','Server Restart','Map Change']
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# DATABASE
	if existsDB(): es.keygroupload(db, func.dbfolder)

	# LOAD GROUPS MODULE
	es.load('sam/core/admins/groups')
	global groups
	groups = es.import_addon('sam/core/admins/groups')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# DATABASE
	es.keygroupdelete(db)

	# UNLOAD GROUPS MODULE
	es.unload('sam/core/admins/groups')

	# DELETE FILTERS
	try: es.addons.unregisterSayFilter(immFilter)
	except: pass
	try: es.addons.unregisterSayFilter(CreateAdminFilter)
	except: pass

	# POPUPS
	func.popupDelete('adminspage')
	func.popupDelete('listpage')
	func.popupDelete('editAdmin')
	func.popupDelete('choosegroup')
	func.popupDelete('noadmins')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	popup = func.simplemenu('adminspage','home')
	popup.addline(func.header(func.langCommon('TITLE_ADMINS')))
	popup.addline(func.line)
	popup.addline('->1. %s' % func.langAdmins('ADD_OPTION'))
	popup.addline('->2. %s' % func.langAdmins('REMOVE_OPTION'))
	popup.addline('->3. %s' % func.langAdmins('EDIT_OPTION'))
	popup.addline(' ')
	popup.addline(func.line)
	popup.addline(' :: %s' % func.langAdmins('ADMIN_GROUPS'))
	popup.addline(func.line)
	popup.addline('->4. %s' % func.langAdmins('GROUP_ADD_OPTION'))
	popup.addline('->5. %s' % func.langAdmins('GROUP_REMOVE_OPTION'))
	popup.addline('->6. %s' % func.langAdmins('GROUP_EDIT_OPTION'))
	popup.addline(' ')
	popup.addline(func.line)
	popup.addline('->0. %s' % func.langCommon('CANCEL'))
	popup.menuselect = optionSelect
	if SEND: popup.send(ID)

# ------------------------------------------------------------------------------- #
def optionSelect(ID, CHOICE, POPUP):
	if CHOICE in (1,2,3):
		OPTIONS = {1:'ADD',2:'REMOVE',3:'EDIT'}
		func.popupDelete('listpage')
		if CHOICE == 1:   popup = func.easymenu(popuplib.easymenu('listpage', None, add),'adminspage')
		elif CHOICE == 2: popup = func.easymenu(popuplib.easymenu('listpage', None, remove),'adminspage')
		elif CHOICE == 3: popup = func.easymenu(popuplib.easymenu('listpage', None, edit),'adminspage')
		popup.settitle(func.header(func.langAdmins('%s_OPTION' % OPTIONS[CHOICE])))
		popup.setdescription(' # %s ' % func.langCommon('CHOOSE_PLAYER'))
		if CHOICE == 1:
			for x in playerlib.getPlayerList('#human'): popup.addoption([x.steamid,x.name], x.name)
		elif CHOICE in (2,3):
			ids = [x.steamid for x in playerlib.getPlayerList('#human')]
			for x in listAdmins():
				if x in ids: update(playerlib.getPlayer(es.getuserid(x)))
				popup.addoption([x,getkey(x,'name')], getkey(x,'name'))
		popup.send(ID)
	elif CHOICE in (4,5,6):
		groups = es.import_addon('sam/core/admins/groups')
		groups.pageChoice(ID, CHOICE)
	elif CHOICE == 10: core.home(ID)
	else: page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def add(ID, TOKEN, POPUP, STATE='no', NOTIFY=True):
	if not isAdmin(TOKEN[0]):
		if not es.exists('keygroup', db): es.keygroupcreate(db)
		es.keycreate(db, TOKEN[0])
		if TOKEN[1]: setkey(TOKEN[0], 'name', TOKEN[1])
		else: setkey(TOKEN[0], 'name', 'WAITING_FOR_ADMIN_TO_JOIN')
		setkey(TOKEN[0], 'group', 'NO_GROUP')
		if STATE == 'no':
			setkey(TOKEN[0], 'immunity', 0)
			setkey(TOKEN[0], 'Ban Level', 0)
		else:
			setkey(TOKEN[0], 'immunity', 100)
			setkey(TOKEN[0], 'Ban Level', 2)
		for x in access: setkey(TOKEN[0], x, STATE)
		if NOTIFY: func.hudhint(ID, func.langAdmins('ADMIN_ADDED', {'admin':getkey(TOKEN[0], 'name')}), func.adminstag)
		edit(ID, TOKEN, None)
	else:
		func.hudhint(ID, func.langAdmins('IS_ADMIN'), func.adminstag)
		page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def remove(ID, TOKEN, POPUP):
	if len(listAdmins()) > 1:
		es.keydelete(db, TOKEN[0])
		es.keygroupsave(db, func.dbfolder)
		func.hudhint(ID, func.langAdmins('ADMIN_REMOVED', {'admin':TOKEN[1]}), func.adminstag)
	else: func.hudhint(ID, func.langAdmins('NEED_ADMINS'), func.adminstag)
	optionSelect(ID, 2, None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def edit(ID, TOKEN, POPUP, PAGE=False):
	func.popupDelete('editAdmin')
	popup = func.easymenu(popuplib.easymenu('editAdmin', None, editSelect),'adminspage')
	popup.c_beginsep = '%s\n# %s: %s\n# ID: %s\n%s' % (func.line,func.langCommon('NAME').upper(),TOKEN[1],TOKEN[0],func.line)
	popup.settitle(func.header(func.langAdmins('EDIT_OPTION')))
	popup.addoption(['toggle',TOKEN[0]], func.langAdmins('TOGGLE_OPTION'))
	popup.addoption(['imm',TOKEN[0]], '%s: %s' % (func.langCommon('IMMUNITY'),getkey(TOKEN[0],'immunity')))
	if getkey(TOKEN[0],'group') == 'NO_GROUP': popup.addoption(['group',TOKEN[0]], '%s: None' % func.langCommon('GROUP'))
	else: popup.addoption(['group',TOKEN[0]], '%s: %s' % (func.langCommon('GROUP'),getkey(TOKEN[0],'group')))
	popup.addoption(['ban',TOKEN[0]], 'Ban Level: %s' % getkey(TOKEN[0],'Ban Level'))
	for x in access:
		if getkey(TOKEN[0],x) == 'yes': popup.addoption([x,TOKEN[0]], '%s: %s' % (x,func.langCommon('YES')))
		else: popup.addoption([x,TOKEN[0]], '%s: %s' % (x,func.langCommon('NO')))
	if not PAGE: popup.send(ID)
	else: popup.sendPage(ID, PAGE)

# ------------------------------------------------------------------------------- #
def editSelect(ID, TOKEN, POPUP):
	token = [TOKEN[1],getkey(TOKEN[1],'name')]
	if TOKEN[0] == 'toggle': toggle(TOKEN[1])
	elif TOKEN[0] == 'imm':
		if not ID in imm: imm[ID] = TOKEN[1]
		func.cloud['filters'].append(ID)
		es.addons.registerSayFilter(immFilter)
		func.hudhint(ID, '%s\n%s' % (func.langAdmins('TOSET_IMMUNITY'),func.langCore('TO_CANCEL_OP')), func.adminstag)
	elif TOKEN[0] == 'group':
		if not len(groups.listGroups()) == 0:
			func.popupDelete('choosegroup')
			popup = func.easymenu(popuplib.easymenu('choosegroup', None, chooseGroup),'listpage')
			popup.settitle(func.header(func.langAdmins('EDIT_OPTION')))
			popup.setdescription(' # %s ' % func.langCommon('CHOOSE_GROUP'))
			if not getkey(TOKEN[1],'group') == 'NO_GROUP': popup.addoption([TOKEN[1],1,token], func.langAdmins('REMOVE_GROUP'))
			for x in groups.listGroups(): popup.addoption([TOKEN[1],x,token], x)
			popup.send(ID)
		else:
			func.hudhint(ID, func.langAdmins('NO_GROUPS'), func.adminstag)
			edit(ID, token, None)
	elif TOKEN[0] == 'ban':
		level = int(getkey(TOKEN[1],'Ban Level')) + 1
		if level < 3: setkey(TOKEN[1],'Ban Level',level)
		else: setkey(TOKEN[1],'Ban Level',0)
	else:
		if getkey(TOKEN[1],TOKEN[0]) == 'yes': setkey(TOKEN[1],TOKEN[0],'no')
		else: setkey(TOKEN[1],TOKEN[0],'yes')
		edit(ID, token, None, func.sendPage(access.index(TOKEN[0])+4))
	if TOKEN[0] in ('toggle','ban'): edit(ID, token, None)

# ------------------------------------------------------------------------------- #
def chooseGroup(ID, TARGET, POPUP):
	if TARGET[1] == 1: setkey(TARGET[0],'group','NO_GROUP')
	else: setkey(TARGET[0],'group',TARGET[1])
	edit(ID, TARGET[2], None)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def existsDB():
	if os.path.isfile(dbpath): return True
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def isAdmin(TARGET):
	if TARGET in listAdmins(): return True
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getkey(ADMIN, KEY): return es.keygetvalue(db, ADMIN, KEY)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def setkey(ADMIN, KEY, VALUE):
	es.keysetvalue(db, ADMIN, KEY, VALUE)
	es.keygroupsave(db, func.dbfolder)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def listAdmins():
	if existsDB(): return [str(x) for x in keyvalues.getKeyGroup(db)]
	else: return []

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def toggle(TARGET):
	for item in access: setkey(TARGET,item,temp['toggle'])
	if temp['toggle'] == 'yes':
		setkey(TARGET,'Ban Level',2)
		temp['toggle'] = 'no'
	else:
		setkey(TARGET,'Ban Level',0)
		temp['toggle'] = 'yes'

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def update(ADMIN):
	setkey(ADMIN.steamid,'name',ADMIN.name)
	for x in access:
		if not es.exists('key',db,ADMIN.steamid,x): setkey(ADMIN.steamid,x,'no')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def can(ADMIN, ITEM, R=False):
	steamid = es.getplayersteamid(ADMIN)
	if ITEM == 'Ban': ITEM = 'Ban Level'
	elif not ITEM in access: ITEM = 'Fun Controls'
	if isAdmin(steamid):
		group = getkey(steamid,'group')
		if not ITEM == 'Ban Level':
			if 'yes' in (getkey(steamid,ITEM),groups.getkey(group,ITEM)): R = True
		else:
			admin = int(getkey(steamid,'Ban Level'))
			if group == 'NO_GROUP' and admin > 0: R = admin
			else:
				x = max(admin,int(groups.getkey(group,'Ban Level')))
				if x > 0: R = x
	if not R: func.hudhint(ADMIN, func.langAdmins('NO_ACCESS'),func.adminstag)
	return R

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def immunity(ADMIN, TARGET, NOTIFY=True, R=True):
	if ADMIN == TARGET and isAdmin(TARGET.steamid):
		admin  = max(int(getkey(ADMIN.steamid,'immunity')),int(groups.getkey(getkey(ADMIN.steamid,'group'),'immunity')))
		target = max(int(getkey(TARGET.steamid,'immunity')),int(groups.getkey(getkey(TARGET.steamid,'group'),'immunity')))
		if admin <= target:
			if NOTIFY: func.hudhint(ADMIN, func.langAdmins('IMM_FALSE'), func.adminstag)
			R = False
	return R

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_activate(EV):
	if isAdmin(EV['es_steamid']): update(playerlib.getPlayer(EV['userid']))

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def immFilter(ID, TEXT, TEAMONLY):
	if ID in imm:
		TEXT = TEXT.strip('"')
		if str(TEXT) == '!cancel': func.hudhint(ID, func.langCore('OP_CANCEL'), func.cloud['tag'])
		elif TEXT.isdigit() and int(TEXT) in range(101):
			setkey(imm[ID], 'immunity', TEXT)
			func.hudhint(ID, func.langAdmins('SET_ADMIN_IMM',{'admin':getkey(imm[ID],'name'),'imm':TEXT}), func.adminstag)
		else: func.hudhint(ID, func.langAdmins('IMM_NOTIN_RANGE'),func.adminstag)
		es.addons.unregisterSayFilter(immFilter)
		edit(ID, [imm[ID],getkey(imm[ID],'name')], None)
		del imm[ID]
		func.cloud['filters'].remove(ID)
		return (0, 0, 0)
	else: return (ID, TEXT, TEAMONLY)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def noAdmins(ID):
	popup = func.simplemenu('noadmins')
	popup.addline(func.header(func.langCommon('TITLE_ADMINS')))
	popup.addline(func.line)
	popup.addline(func.langAdmins('NOADMINS_LINE1'))
	popup.addline(func.langAdmins('NOADMINS_LINE2'))
	popup.addline(' ')
	popup.addline(func.langAdmins('NOADMINS_LINE3'))
	popup.addline('->1. %s' % func.langCommon('YES'))
	popup.addline('->2. %s' % func.langCommon('NO'))
	popup.addline(func.line)
	popup.addline('->0. %s' % func.langCommon('CANCEL'))
	popup.menuselect = noAdminsSelect
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def noAdminsSelect(ID, CHOICE, POPUP):
	if CHOICE == 1:
		temp['noadmins'] = ID
		es.addons.registerSayFilter(CreateAdminFilter)
		func.tell(ID, '#spec'+func.langAdmins('CONFIRM_RCON'), func.adminstag)
	elif CHOICE in range(3,10): noAdmins(ID)
	elif CHOICE in (10,2,1): func.popupDelete('noadmins')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def CreateAdminFilter(ID, TEXT, TEAM):
	if temp['noadmins'] == ID:
		rcon = str(es.ServerVar('rcon_password'))
		TEXT = str(TEXT.strip('"'))
		if TEXT == rcon:
			page(ID, False)
			add(ID, [es.getplayersteamid(ID),es.getplayername(ID)], None, 'yes', False)
			func.hudhint(ID, func.langAdmins('RCON_CONFIRMED'), func.adminstag)
		else: func.hudhint(ID, func.langAdmins('RCON_INCORRECT'), func.adminstag)
		try: es.addons.unregisterSayFilter(CreateAdminFilter)
		except: pass
		return (0, 0 ,0)
		del temp['noadmins']
	else: return (ID, TEXT, TEAM)

# =============================================================================== #