# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
from __future__ import with_statement
import es, popuplib, playerlib, time, keyvalues, os, gamethread, cmdlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
core     = es.import_addon('sam/core')
admins   = es.import_addon('sam/core/admins')
pcontrol = es.import_addon('sam/core/pcontrol')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
db     = 'sam_bans'
dbpath = func.dbPath + 'es_%s_db.txt' % db
TEMP   = {} # Temporary data holder
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxxx # BAN LEVELS # xxxxxxxxxx #
level = {1:{'5m':300,'30m':1800,'1h':3600,'3h':10800,'1d':86400},
		 2:{'3d':259200,'1w':604800,'1m':2592000,'1':31536000}}
sort  = ('perm','5m','30m','1h','3h','1d','3d','1w','1mo','1y')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# DATABASE
	if existsDB(): es.keygroupload(db, func.dbfolder)

	# CMDS
	cmdlib.registerSayCommand('!ban', banCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_ban', banCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!unban', unbanCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_unban', unbanCMD, 'SAM CMD')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# DATABASE
	es.keygroupdelete(db)

	# CMDS
	cmdlib.unregisterSayCommand('!ban')
	cmdlib.unregisterSayCommand('!sam_ban')
	cmdlib.unregisterSayCommand('!unban')
	cmdlib.unregisterSayCommand('!sam_unban')

	# POPUPS
	func.popupDelete('BanPList')
	func.popupDelete('BanGetTime')
	func.popupDelete('BanGetReason')
	func.popupDelete('UnbanPList')
	func.popupDelete('banProfile')

# =============================================================================== #
# === <<<> BAN BLOCK <>>> ======================================================= #
# =============================================================================== #
def banPage(ID):
	func.popupDelete('BanPList')
	popup = func.easymenu(popuplib.easymenu('BanPList', None, getTime),'pcontrol')
	popup.settitle(func.header(func.langPcontrol('BAN')))
	for x in playerlib.getPlayerList('#human'): popup.addoption(x, x.name)
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getTime(ID, TARGET, POPUP):
	if admins.immunity(playerlib.getPlayer(ID),TARGET):
		TEMP[TARGET.STEAMID] = {'name':TARGET.name,'admin':es.getplayername(ID)}
		func.popupDelete('BanGetTime')
		popup = func.easymenu(popuplib.easymenu('BanGetTime', None, getReason),'BanPList')
		popup.settitle(func.header(func.langPcontrol('FOR_HOW_LONG')))
		i = admins.can(ID,'Ban')
		for x in sort:
			if i == 1:
				if x in level[1]: popup.addoption([x,TARGET], x.replace(x,func.langPcontrol(x.upper())))
			elif i == 2: popup.addoption([x,TARGET], x.replace(x,func.langPcontrol(x.upper())))
		popup.send(ID)
	else:
		pcontrol.page(ID, False)
		banPage(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getReason(ID, TOKENS, POPUP):
	TEMP[TOKENS[1].steamid]['length'] = TOKENS[0].upper()
	if TOKENS[0] == 'perm': TEMP[TOKENS[1].steamid]['banid'] = 'perm'
	if TOKENS[0] in level[1]: TEMP[TOKENS[1].steamid]['banid'] = int(time.time()) + level[1][TOKENS[0]]
	if TOKENS[0] in level[2]: TEMP[TOKENS[1].steamid]['banid'] = int(time.time()) + level[2][TOKENS[0]]
	if len(getReasons()) > 0:
		func.popupDelete('BanGetReason')
		popup = func.easymenu(popuplib.easymenu('BanGetReason', None, ban),'BanGetTime')
		popup.settitle(func.header(func.langPcontrol('FOR_WHAT_REASON')))
		for x in getReasons(): popup.addoption([x,TOKENS[1]], x)
		popup.send(ID)
	else: ban(ID, ['',TOKENS[1]], None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ban(ID, TOKENS, POPUP, MSG=True, SEND=True):
	target = TOKENS[1].steamid
	TEMP[target]['reason'] = TOKENS[0]
	if not es.exists('keygroup', db): es.keygroupcreate(db)
	if not es.exists('key', db, target): es.keycreate(db, target)
	for x in TEMP[target]: es.keysetvalue(db, target, x, TEMP[target][x])
	es.keygroupsave(db, func.dbfolder)
	if es.exists('userid', TOKENS[1]):
		TOKENS[1].kick(reason=func.langPcontrol('BAN_REASON', getBan(target)))
		if MSG: gamethread.delayed(.1, func.tell, ('#all', func.langPcontrol('TARGET_BANNED', getBan(target)), '#greenBAN'))
	if SEND: banPage(ID)

# =============================================================================== #
# === <<<> UNBAN BLOCK <>>> ===================================================== #
# =============================================================================== #
def unbanPage(ID, SEND=True):
	banlist = getAllBans()
	if len(banlist) > 0:
		func.popupDelete('UnbanPList')
		popup = func.easymenu(popuplib.easymenu('UnbanPList', None, banProfile),'pcontrol')
		popup.settitle(func.header(func.langPcontrol('UNBAN')))
		for x in banlist:
			target = getBan(x)
			popup.addoption(x, '%s [%s]' % (target['name'],func.langPcontrol(target['length'])))
		popup.send(ID)
	else:
		if SEND: pcontrol.page(ID)
		func.hudhint(ID, func.langPcontrol('NO_BANNED_PLAYERS'), 'UNBAN')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def banProfile(ID, TARGET, POPUP):
	target   = getBan(TARGET)
	TEMP[ID] = TARGET
	popup = func.simplemenu('banProfile','UnbanPList')
	popup.addline(func.header(func.langPcontrol('UNBAN')))
	popup.addline(func.line)
	popup.addline(' # %s: %s' % (func.langCommon('NAME').upper(),target['name']))
	popup.addline(' # ID: %s' % (target['steamid']))
	popup.addline(' # %s: %s' % (func.langCommon('LENGTH').upper(), func.langPcontrol('PERM')))
	popup.addline(' # ADMIN: %s' % target['admin'])
	popup.addline(' # %s: %s' % (func.langCommon('REASON').upper(), target['reason']))
	popup.addline(' \n%s' % func.langPcontrol('CONFIRM_UNBAN'))
	popup.addline('->1. %s' % func.langCommon('YES'))
	popup.addline('->2. %s' % func.langCommon('NO'))
	popup.addline(func.line)
	popup.addline('0. %s' % func.langCommon('CANCEL'))
	popup.menuselect = unbanChoice
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def unbanChoice(ID, CHOICE, POPUP):
	if CHOICE == 1:
		func.hudhint(ID, func.langPcontrol('TARGET_UNBANNED', getBan(TEMP[ID])), 'UNBAN')
		es.keydelete(db, TEMP[ID])
		es.keygroupsave(db, func.dbfolder)
		unbanPage(ID)
	elif CHOICE == 2: unbanPage(ID)
	else: banProfile(ID, TEMP[ID], None)
	del TEMP[ID]

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getBan(TARGET):
	a = {'steamid':TARGET}
	for x in ('name','admin','banid','reason','length'): a[x] = es.keygetvalue(db, TARGET, x)
	return a

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def isBanned(TARGET, R=False):
	if existsDB() and es.exists('key', db, TARGET):
		banid = es.keygetvalue(db, TARGET, 'banid')
		if banid == 'perm': R = True
		elif int(banid) > int(time.time()): R = True
		else:
			es.keydelete(db, TARGET)
			es.keygroupsave(db, func.dbfolder)
	return R

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getAllBans():
	if existsDB(): return [x for x in keyvalues.getKeyGroup(db) if isBanned(x)]
	else: return []

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getReasons():
	with open(func.reasonsfile) as f: return [line.strip('-').strip(' ').strip('\n') for line in f.readlines() if line.startswith('-')]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def existsDB():
	if os.path.isfile(dbpath): return True
	else: return False

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def ban(ID, ARGS): pass

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unban(ID, ARGS): pass

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_activate(EV):
	if isBanned(EV['es_steamid']):
		target = playerlib.getPlayer(EV['userid'])
		target.kick(reason=func.langPcontrol('BAN_REASON', getBan(target.steamid)))

# =============================================================================== #